//
// X_db.h
//
// SQL implementation, written by Zoran Constantinescu <zoran@idi.ntnu.no>
//
#ifndef _X_db_h_
#define _X_db_h_

#include "Object.h"
#include "DocumentRef.h"

class X_db
{
  protected:
    X_db() { ; }
  public:
    ~X_db() { ; }

  public:
    virtual int AddURL (String &sDocURL, int &nDocID, String &sDocRefs) { ; }
    virtual int GetURL (int nDocID, String &sDocURL) { ; }
    virtual int GetDocID (String &sDocURL, int &nDocID) { ; }
    virtual int GetNewURL (String &sDocURL, int &nDocID, int &nServerID) { ; }
    virtual int GetNewURL (String &sDocURL, int &nDocID, int &nServerID, 
                           String &sLimitDom) { ; }
    virtual int AddDocInfo (int nDocID, DocumentRef *doc, int bUpdateURL) { ; }
    virtual int AddDocInfoLater (int nDocID, DocumentRef *doc, int bUpdateURL) { ; }
    virtual int GetDocInfo (int nDocID, DocumentRef *doc) { ; }

    virtual int AddLink (int nDocID, char *pWord, int nWordCount,
                         int nPosition, int nWeight, int nAnchor) { ; }
    virtual int DelLinks (int nDocID) { ; }
    virtual int GetLinks (int nWordID, String &sResult) { ; }
    virtual int DelTmpLinks (void) { ; }
    virtual int CopyTmpLinks (void) { ; }
    virtual int CopyTmpLinksN (int nNo) { ; }

    virtual int AddEmail (String &sEmail, int nDocID) { ; }

    virtual int AddServer (String &sServURL, int &nServID, int nServStatus) { ; }
    virtual int UpdateServer (int nServID, int nServStatus) { ; }

    virtual int AddWord (String &sWordTxt, int &nWordID) { ; }
    virtual int AddWord (String &sWordTxt, int &nWordID,
                         String &sWordRootTxt, int &nWordRootID) { ; }
    virtual int GetWordRoot (String &sWord, int &nWordID, 
                             String &sWordRoot, int &nWordRootID) { ; }
    virtual int GetWordID (String &sWordRoot, int &nWordID) { ; }
    virtual int GetWords (int nWordRootID, String &sResult, String &sResultID) { ; }

    virtual int AddSearch (int &nSearchID, time_t tSearchDate,
                     String &sWords, int nSearchStatus, int nSearchSecs,
                     String &sRemoteHost, String &sRemoteAddr,
                     String &sHttpUserAgent, String &sHttpFrom) { ; }

    virtual void Lock (String &s) { ; }
    virtual void UnLock () { ; }
};

#endif


